(c-declare #<<c-declare-end
#include "stringConv.hpp"

___ERR_CODE SCMOBJ_to_string (___SCMOBJ src, string* dst, int arg_num)
{
  ___SCMOBJ ___temp; // used by ___STRINGP

  if (!___STRINGP(src))
    return ___STOC_UCS_2STRING_ERR+arg_num;

  unsigned int n = ___INT(___STRINGLENGTH(src));
  string r;

  while (n-- > 0)
  {
    ___UCS_4 c = ___INT(___STRINGREF(src,___FIX(n)));
    if (c > 0xffff) // UCS-2 is 16 bits
      return ___STOC_UCS_2STRING_ERR+arg_num;
    r[n] = c;
  }

  *dst = r;

  return ___NO_ERR;
}

___ERR_CODE string_to_SCMOBJ (string src, ___SCMOBJ* dst, int arg_num)
{
  unsigned int n = src.length ();
  ___SCMOBJ r = ___alloc_scmobj (___sSTRING, n<<___LCS, ___STILL);

  if (___FIXNUMP(r))
  {
    *dst = ___FAL;
    return ___CTOS_HEAP_OVERFLOW_ERR+arg_num;
  }

  while (n-- > 0)
  {
    ___UCS_4 c = src[n];
    if (c > ___MAX_CHR)
    {
      ___release_scmobj (r);
      *dst = ___FAL;

      return ___CTOS_UCS_2STRING_ERR+arg_num;
    }
    ___STRINGSET(r,___FIX(n),___CHR(c))
  }

  *dst = r;

  return ___NO_ERR;
}

c-declare-end
)
